/*
Link Alert
Version: 0.8
Author:  Conlan Wesson
Date:    28 Jan 2007
Purpose: Changes the cursor to indicate the target of a link.
*/
var LinkAlert = {
	toID: null,
	
	onLoad: function(){
		if("arguments" in window && window.arguments.length > 0) {
			this.toID = window.arguments[0];	
	
		}
	},
	
	onAccept: function(){
		window.opener.document.getElementById(this.toID).value = document.getElementById("linkalert-icon-imagePath").value;
		window.close();
	},
	
	onCancel: function(){
		window.close();
	},
	
	setFileDeck: function(){
		document.getElementById("linkalert-file-deck").selectedIndex = document.getElementById("linkalert-file-type").selectedIndex;
	},

	setFilePath: function(){
		var icoType = document.getElementById("linkalert-file-type").selectedIndex;
		var part1 = "";
		var part2 = "";
		switch(icoType){
			case 0:{
				part1 = "%LASKIN%/%LASIZE%/";
				part2 = document.getElementById("linkalert-icon-la-list").value + "-icon.png";
				break;
			}
			case 1:{
				part1 = "moz-icon://";
				if(document.getElementById("linkalert-icon-os-list").value == "%LAEXT%")
					part2 = ".%LAEXT%";
				else
					part2 = document.getElementById("linkalert-icon-os-specific-ext").value;
				part2 += "?size=%LASIZEPX%";
				break;
			}
			case 2:{
				part1 = "file:///";
				part2 = document.getElementById("linkalert-icon-file-path").value;
				break;
			}
			default:{
				part1 = "ERROR";
				break;
			}
		}
		document.getElementById("linkalert-icon-imagePath").value = part1 + part2;
		document.getElementById("linkalert-icon-demo").src = this.replacePath((part1 + part2),document.getElementById("linkalert-icon-demo-list").value);
	},

	getIcon: function() {
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker); 
		var tempBundle = document.getElementById("linkalert-fileselect-bundle-prop");
		fp.init(window, tempBundle.getString("selecticon"), nsIFilePicker.modeOpen);
		fp.appendFilters(nsIFilePicker.filterImages);
		
		var rv = fp.show();
		if (rv == nsIFilePicker.returnOK) {
			document.getElementById("linkalert-icon-file-path").value = fp.file.path;
			this.setFilePath();
		}
	},

	replacePath: function(path,force){
		var path = path.replace(/%LASKIN%/g,"chrome://linkalert/skin");
		if((force == 2) && force != 1){
			path = path.replace(/%LASIZE%/g,"large");
			path = path.replace(/%LASIZEPX%/g,"32");
		}else{
			path = path.replace(/%LASIZE%/g,"small");
			path = path.replace(/%LASIZEPX%/g,"16");
		}
		path = path.replace(/%LAEXT%/g,document.getElementById("linkalert-icon-demo-ext").value);
		path = path.replace(/%LAPROTO%/g,document.getElementById("linkalert-icon-demo-proto").value);
		return path;
	},
}