/*
Link Alert
Version: 0.8
Author:  Conlan Wesson
Date:    28 Jan 2007
Purpose: Changes the cursor to indicate the target of a link.
*/
var LinkAlert = {
	
	startUp: function()
	{
		LinkAlert.getPrefs();
		//Add onMouseMove
		window.addEventListener("mousemove", LinkAlert.moveIcon, false);
		window.addEventListener("scroll", LinkAlert.moveIcon, false);
	},
	
	moveIcon: function(e)
	{
		try{
			var iconBox = content.document.getElementById("linkalert-box");
			if (!iconBox){ LinkAlert.addIcon(); } //Check that icon exists
			var iconImage = new Array();
			for(var i = 0; i < useNumber; i++)
				iconImage[i] = content.document.getElementById("linkalert-icon-"+(i+1));
		}catch(err){}
		
		try {
			var moveTarget = e.target;
			while (moveTarget.nodeName.toLowerCase() != "#document" && moveTarget.nodeName.toUpperCase() != "A")
			{//Find <A> if not current node
				moveTarget = moveTarget.parentNode;
			}
			
			if (moveTarget.nodeName.toUpperCase() == "A" && moveTarget.href) {
				//Get frame offset
				/*var frameX = 0;
				var frameY = 0;
				var currentNode = moveTarget.ownerDocument.defaultView.frameElement; //Check for inside a frame
				while(currentNode){
					var framePos = Position.get(currentNode);
					frameX += (framePos.left - currentNode.scrollLeft);
					frameY += (framePos.top - currentNode.scrollTop);
					currentNode = currentNode.ownerDocument.defaultView.frameElement;
				}*/
				//Code provided by Dani Church
				var frameX = 0;
				var frameY = 0;
				var isFixed = false;
				var currentNode = moveTarget;
				// Check to see if anything in the link's ancestry is fixed
				while (currentNode) {
					if (window.getComputedStyle(currentNode, "").position == "fixed") {
						isFixed = true;
						break;
					}
					currentNode = currentNode.offsetParent;
				}
				currentNode = moveTarget.ownerDocument.defaultView.frameElement; //Check for inside a frame
				while(currentNode){
					if (!isFixed) {
						frameX -= currentNode.contentWindow.scrollX;
						frameY -= currentNode.contentWindow.scrollY;
					}
					isFixed = false;
					while(currentNode && currentNode.nodeName.toLowerCase() != "#document"){
						var curStyle = window.getComputedStyle(currentNode, "");
						frameX += currentNode.offsetLeft;
						frameY += currentNode.offsetTop;
						if (currentNode.nodeName.toLowerCase() != "body") {
							frameX -= currentNode.scrollLeft;
							frameY -= currentNode.scrollTop;
						}
						if (!currentNode.offsetParent) {
							currentNode = currentNode.parentNode;
						} else if (curStyle.position == "fixed") {
							isFixed = true;
							currentNode = currentNode.ownerDocument;
						} else if (curStyle.position == "absolute") {
							currentNode = currentNode.offsetParent;
						} else {
							var scrollNode = currentNode.parentNode;
							currentNode = currentNode.offsetParent;
							while (scrollNode && scrollNode != currentNode) {
								frameX -= scrollNode.scrollLeft;
								frameY -= scrollNode.scrollTop;
								scrollNode = scrollNode.parentNode;
							}
						}
					}
					if (currentNode) {
						currentNode = currentNode.defaultView.frameElement; //Find next higher frame
					}
				}
				if (isFixed) {
					frameX += content.document.body.scrollLeft;
					frameY += content.document.body.scrollTop;
				}
				//END Dani Church's code
				//Get X,Y Coords of Mouse
				iconX = e.pageX + offsetX + frameX;
				iconY = e.pageY + offsetY + frameY;
				documentWidth = content.document.width;
				documentHeight = content.document.height;
				//Move Icon
				iconBox.style.left = iconX + "px";
				iconBox.style.top = iconY + "px";
				var iconSrc = new Array();
				for(var i = 0; i < useNumber; i++)
					iconSrc[i] = "none";
				
				//Get link info
				var linkHref = moveTarget.href.toLowerCase();
				var linkTarget = moveTarget.target.toLowerCase();
				var linkProtocol = moveTarget.protocol.toLowerCase();
				var pageHref = content.document.location.href.toLowerCase();
				var pageProtocol = content.document.location.protocol.toLowerCase();
				//Remove parameters
				linkProtocol = linkProtocol.substr(0,linkProtocol.length-1);
				pageProtocol = pageProtocol.substr(0,pageProtocol.length-1);
				if (linkHref.indexOf("?") != -1)
					linkHref = linkHref.substr(0,linkHref.indexOf("?"));
				if (linkHref.indexOf("#") != -1)
					linkHref = linkHref.substr(0,linkHref.indexOf("#"));
				if (pageHref.indexOf("?") != -1)
					pageHref = pageHref.substr(0,pageHref.indexOf("?"));
				if (pageHref.indexOf("#") != -1)
					pageHref = pageHref.substr(0,pageHref.indexOf("#"));
				var linkExtension = linkHref.substr(linkHref.lastIndexOf(".")+1);
				
				//Get Link domain
				var linkDomain = moveTarget.hostname;
				while(linkDomain.indexOf(".") != linkDomain.lastIndexOf("."))
					linkDomain = linkDomain.substr(linkDomain.indexOf(".")+1);
				//Get Page domain
				var pageDomain = content.document.location.hostname;
				while(pageDomain.indexOf(".") != pageDomain.lastIndexOf("."))
					pageDomain = pageDomain.substr(pageDomain.indexOf(".")+1);
				
				//Process priority order
				var iconAt = 0;
				for(var i = 4; i >= 0; i--){
					switch(priority[i]){
						case "inex":
							//Check for external link
							if(showExternal == true && linkDomain != pageDomain && linkDomain != ""){
								iconSrc[iconAt] = "%LASKIN%/%LASIZE%/external-icon.png";
								iconAt++;
							//Check for internal link 
							}else if(showInternal == true && pageHref == linkHref && moveTarget.href.indexOf("#") != -1){
								iconSrc[iconAt] = "%LASKIN%/%LASIZE%/internal-icon.png";
								iconAt++;
							}
							break;
						case "newWindow":
							//Check New Window
							if (showNewWindow && (linkTarget == "_blank" || linkTarget == "_new" || linkTarget == "_newwindow")){
								iconSrc[iconAt] = "%LASKIN%/%LASIZE%/new-icon.png";
								iconAt++;
							}
							break;
						case "proto":
							//Check Protocol
							var x = showProtocols.lastIndexOf(linkProtocol + ",");
							if (x != -1 && linkProtocol != "" && (protoIfDiff == false || linkProtocol != pageProtocol)){
								var u = showProtocols.indexOf(":",x);
								var n = showProtocols.indexOf(";",u);
								iconSrc[iconAt] = showProtocols.substr(u+1,n-u-1);
								iconAt++;
							}
							break;
						case "rss":
							//Check for RSS Feed
							if(showRSS == true && linkHref.search("rss") != -1){
								iconSrc[iconAt] = "%LASKIN%/%LASIZE%/rss-icon.png";
								iconAt++;
							}
							break;
						case "ext":
							//Check File Extension
							linkExtension = ("." + linkExtension + ",");
							var x = showExtensions.lastIndexOf(linkExtension);
							if (x != -1 && linkExtension != "") {
								var u = showExtensions.indexOf(":",x);
								var n = showExtensions.indexOf(";",u);
								iconSrc[iconAt] = showExtensions.substr(u+1,n-u-1);
								iconAt++;
							}
							break;
						default:
							break;
					}
				}
				//Change and Show Icon
				var anyIcon = false;
				var boxWidth = 0;
				for(var i = 0; i < useNumber; i++){
					if(iconSrc[i] != "none") {
						var iconPath = iconSrc[i];
						iconPath = iconPath.replace(/%LASKIN%/g,"chrome://linkalert/skin");
						if(useLarge == true){
							iconPath = iconPath.replace(/%LASIZE%/g,"large");
							iconPath = iconPath.replace(/%LASIZEPX%/g,"32");
							iconImage[i].style.width = "32px";
							boxWidth += 32;
							iconBox.style.height = "32px";
						}else{
							iconPath = iconPath.replace(/%LASIZE%/g,"small");
							iconPath = iconPath.replace(/%LASIZEPX%/g,"16");
							iconImage[i].style.width = "16px";
							boxWidth += 16;
							iconBox.style.height = "16px";
						}
						iconPath = iconPath.replace(/%LAEXT%/g,linkExtension.substring(1,linkExtension.length-1));
						iconPath = iconPath.replace(/%LAPROTO%/g,linkProtocol);
						if( iconImage[i].src != iconPath)
							iconImage[i].src = iconPath;
						anyIcon = true;
					}else{
						iconImage[i].style.width = "0px";
					}
				}
				//Correct Off the edge
				if (iconX + boxWidth > documentWidth){
					iconX -= (2 * offsetX) + boxWidth;
					iconBox.style.left = iconX + "px";
				}
				if (iconY + iconBox.style.height > documentHeight){
					iconY -= (2 * offsetY) + iconBox.style.height;
					iconBox.style.top = iconY + "px";
				}
				//Show icons
				if(anyIcon == true){
					iconBox.style.width = boxWidth + "px";
					iconBox.style.visibility="visible";
				}else{
					iconBox.style.width = "0px";
					iconBox.style.visibility="hidden";
				}
			}else{ //if not "A"
				//Hide Icon
				iconBox.style.visibility="hidden";
			}// END if (moveTarget.nodeName
		}catch(err){
			if(iconBox){ iconBox.style.visibility="hidden"; }
		}// END try
	},// END function move
	
	addIcon: function()
	{
		if (!iconBox)
		{ //Create the Icon
			var iconBox = content.document.createElement("div");
			iconBox.setAttribute("id","linkalert-box");
			var iconStyle = "position:absolute;left:0px;top:0px;z-index:1000000000 !important;visibility:hidden;"
			if(useBackground == true)
			{iconStyle += ("background-color:" + useBackgroundColor + " !important;");}
			if(useBorder == true)
			{iconStyle += ("border:" + useBorderColor + " " + useBorderWidth + "px solid !important;padding:2px !important;");}
			iconBox.setAttribute("style",iconStyle);
			iconBox.style.opacity = (useOpacity/100);
			var iconImage = new Array();
			for(var i = 0; i < useNumber; i++){
				iconImage[i] = content.document.createElement("img");
				iconImage[i].setAttribute("id","linkalert-icon-"+(i+1));
				iconImage[i].setAttribute("src","chrome://linkalert/skin/none-icon.png");
				iconBox.appendChild(iconImage[i]);
			}
			content.document.body.appendChild(iconBox);
		}
	},// END function addIcon
	
	getPrefs: function()
	{
		var prefs = Components.classes["@mozilla.org/preferences-service;1"]
			.getService(Components.interfaces.nsIPrefService)
			.getBranch("linkalert.");
		prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
		//Get Prefs
		showExtensions = prefs.getCharPref("icons.extensions");
		showProtocols = prefs.getCharPref("icons.protocols");
		protoIfDiff = prefs.getBoolPref("icons.protocols.ifDifferent");
		customExtensions = prefs.getCharPref("icons.custom.extensions");
		customProtocols = prefs.getCharPref("icons.custom.protocols");
		showExternal = prefs.getBoolPref("special.showExternal");
		showInternal = prefs.getBoolPref("special.showInternal");
		showNewWindow = prefs.getBoolPref("special.showNewWindow");
		showRSS = prefs.getBoolPref("special.showRSS");
		useLarge = prefs.getBoolPref("icons.useLarge");
		useBackground = prefs.getBoolPref("display.background");
		useBackgroundColor = prefs.getCharPref("display.background.color");
		useBorder = prefs.getBoolPref("display.border");
		useBorderColor = prefs.getCharPref("display.border.color");
		useBorderWidth = prefs.getIntPref("display.border.width");
		useOpacity = prefs.getIntPref("display.opacity");
		useNumber = prefs.getIntPref("display.number");
		offsetX = prefs.getIntPref("offset.x");
		offsetY = prefs.getIntPref("offset.y");
		priority = prefs.getCharPref("priority");
		//Merge default and custom icons
		showExtensions += customExtensions;
		showProtocols += customProtocols;
		//Split priorities
		priority = priority.split(",");
		//Correct for changes
		var versionTemp = prefs.getCharPref("firstRun").split(".");
		var version = 0;
		for(var x = 0; x < versionTemp.length; x++){
			version *= 10;
			version += parseInt(versionTemp[x]);
		}
		if(version < 56){ LinkAlert.fixPrefs(version); }
			
	},// END function getPrefs
	
	fixPrefs: function(version)
	{
		var prefs = Components.classes["@mozilla.org/preferences-service;1"]
			.getService(Components.interfaces.nsIPrefService)
			.getBranch("linkalert.");
		prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
		if(version < 55){
			if(prefs.prefHasUserValue("icons.targets")){
				if(prefs.getCharPref("icons.targets").toLowerCase() == ""){
					showNewWindow = false;
				}
				prefs.setBoolPref("special.showNewWindow",showNewWindow);
			}
		}
		if(version < 56){
			if(showExtensions.search("%LASKIN%") == -1){
				showExtensions = showExtensions.replace(/,:/g,",:%LASKIN%/%LASIZE%/");
				showExtensions = showExtensions.replace(/;/g,"-icon.png;");
				prefs.setCharPref("icons.extensions",showExtensions);
			}
			if(showProtocols.search("%LASKIN%") == -1){
				showProtocols = showProtocols.replace(/,:/g,",:%LASKIN%/%LASIZE%/");
				showProtocols = showProtocols.replace(/;/g,"-icon.png;");
				prefs.setCharPref("icons.protocols",showProtocols);
			}
		}
		prefs.setCharPref("firstRun","0.5.6");
	}// END function fixPrefs
	
}// END LinkAlert

//Set onLoad Listner
window.addEventListener("load", function() { LinkAlert.startUp(); }, false);