/*
Link Alert
Version: 0.8
Author:  Conlan Wesson
Date:    28 Jan 2007
Purpose: Changes the cursor to indicate the target of a link.
*/

var LinkAlert = {
	
	//Set Icon Usage
	iconExtensionSrc: new Array("%LASKIN%/%LASIZE%/doc-icon.png","%LASKIN%/%LASIZE%/app-icon.png","%LASKIN%/%LASIZE%/img-icon.png","%LASKIN%/%LASIZE%/jse-icon.png","%LASKIN%/%LASIZE%/aud-icon.png","%LASKIN%/%LASIZE%/vid-icon.png","%LASKIN%/%LASIZE%/pdf-icon.png","%LASKIN%/%LASIZE%/ppt-icon.png","%LASKIN%/%LASIZE%/reg-icon.png","%LASKIN%/%LASIZE%/txt-icon.png","%LASKIN%/%LASIZE%/torrent-icon.png","%LASKIN%/%LASIZE%/xls-icon.png","%LASKIN%/%LASIZE%/xpi-icon.png","%LASKIN%/%LASIZE%/zip-icon.png"),
	iconProtocolSrc: new Array("%LASKIN%/%LASIZE%/aim-icon.png","%LASKIN%/%LASIZE%/ftp-icon.png","%LASKIN%/%LASIZE%/secure-icon.png","%LASKIN%/%LASIZE%/unsecure-icon.png","%LASKIN%/%LASIZE%/jsp-icon.png","%LASKIN%/%LASIZE%/mail-icon.png"),
	iconExtension: new Array(".doc,",".exe,.msi,",".jpg,.gif,.png,.bmp,",".js,.jse,",".mp3,.wma,.wav,",".mpg,.wmv,",".pdf,",".ppt,.pps,.ppa,",".reg,",".txt,",".torrent,",".xls,",".xpi,",".zip,.rar,.gz,.7z,.tar,.tgz,"),
	iconProtocol: new Array("aim,","ftp,","https,","http,","javascript,","mailto,"),
	iconExtensionIDs: new Array("doc","app","img","jse","aud","vid","pdf","ppt","reg","txt","torrent","xls","xpi","zip"),
	iconProtocolIDs: new Array("aim","ftp","secure","unsecure","jsp","mail"),
	iconCustomExt: new Array(),
	iconCustomProto: new Array(),
	
	loadPrefs: function(paneSelected) {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"]
			.getService(Components.interfaces.nsIPrefService)
			.getBranch("linkalert.");
		prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
		//Get user settings
		showExtensions = prefs.getCharPref("icons.extensions");
		showProtocols = prefs.getCharPref("icons.protocols");
		customExtensions = prefs.getCharPref("icons.custom.extensions");
		customProtocols = prefs.getCharPref("icons.custom.protocols");
		demoIcon = prefs.getCharPref("icons.demo");
		showExternal = prefs.getBoolPref("special.showExternal");
		showNewWindow = prefs.getBoolPref("special.showNewWindow");
		showRSS = prefs.getBoolPref("special.showRSS");
		useLarge = prefs.getBoolPref("icons.useLarge");
		useBackground = prefs.getBoolPref("display.background");
		backgroundColor = prefs.getCharPref("display.background.color");
		useBorder = prefs.getBoolPref("display.border");
		useOpacity = prefs.getIntPref("display.opacity");
		borderColor = prefs.getCharPref("display.border.color");
		priority = prefs.getCharPref("priority");
		
		if(paneSelected == 0){
			//Display extension prefs
			for(var i = 0; i < LinkAlert.iconExtensionSrc.length; i++) {
				if (showExtensions.search(LinkAlert.iconExtensionIDs[i]) != -1) {
					document.getElementById("linkalert-show-" + LinkAlert.iconExtensionIDs[i]).checked = true;
				}else{
					document.getElementById("linkalert-show-" + LinkAlert.iconExtensionIDs[i]).checked = false;
				}
			}
			
			//Display protocol prefs
			for(var i = 0; i < LinkAlert.iconProtocolSrc.length; i++) {
				if (showProtocols.search(LinkAlert.iconProtocolIDs[i]) != -1) {
					document.getElementById("linkalert-show-" + LinkAlert.iconProtocolIDs[i]).checked = true;
				}else{
					document.getElementById("linkalert-show-" + LinkAlert.iconProtocolIDs[i]).checked = false;
				}
			}
			
		}else if(paneSelected == 1){
			//Display custom extensions
			var customTemp = customExtensions.split(";");
			for(var i = 0; i < customTemp.length-1; i++){
				var tempSplit = customTemp[i].substring(0,customTemp[i].indexOf(":"));
				var tempSrc = customTemp[i].substring(customTemp[i].indexOf(":")+1);
				LinkAlert.iconCustomExt[i] = tempSplit.split(",");
				var iconPath = LinkAlert.replacePath(tempSrc);
				var tempItem = document.createElement("listitem");
				tempItem.setAttribute("id","linkalert-extensions-src-"+tempSrc);
				tempItem.setAttribute("class","listitem-iconic");
				tempItem.setAttribute("label",tempSrc);
				tempItem.setAttribute("image",iconPath);
				if(tempSrc != ""){
					document.getElementById("linkalert-extensions-src").appendChild(tempItem);
				}
			}
			//Display custom protocols
			var customTemp = customProtocols.split(";");
			for(var i = 0; i < customTemp.length; i++){
				var tempSplit = customTemp[i].substring(0,customTemp[i].indexOf(":"));
				var tempSrc = customTemp[i].substring(customTemp[i].indexOf(":")+1);
				LinkAlert.iconCustomProto[i] = tempSplit.split(",");
				var iconPath = LinkAlert.replacePath(tempSrc);
				var tempItem = document.createElement("listitem");
				tempItem.setAttribute("id","linkalert-protocols-src-"+tempSrc);
				tempItem.setAttribute("class","listitem-iconic");
				tempItem.setAttribute("label",tempSrc);
				tempItem.setAttribute("image",iconPath);
				if(tempSrc != ""){
					document.getElementById("linkalert-protocols-src").appendChild(tempItem);
				}
			}
			
		}else if(paneSelected == 2){
			//Display priority
			var priorityTemp = priority.split(",");
			var tempBundle = document.getElementById("linkalert-bundle-prop");
			for(var i = 4; i >= 0; i--){
				var tempItem = document.createElement("listitem");
				tempItem.setAttribute("id","linkalert-priority-"+priorityTemp[i]);
				tempItem.setAttribute("label",tempBundle.getString("priority"+priorityTemp[i]));
				tempItem.setAttribute("value",priorityTemp[i]);
				document.getElementById("linkalert-priority").appendChild(tempItem);
			}
			//Display Opacity
			document.getElementById("linkalert-large-icons-small").src = LinkAlert.replacePath(demoIcon,1);
			document.getElementById("linkalert-large-icons-large").src = LinkAlert.replacePath(demoIcon,2);
			LinkAlert.opacityDemo();
		}
	},// END function loadPrefs
	
	savePrefs: function() {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"]
			.getService(Components.interfaces.nsIPrefService)
			.getBranch("linkalert.");
		prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
		
		showExtensions = "";
		showProtocols = "";
		//Set extension prefs
		for(var i = 0; i < LinkAlert.iconExtensionSrc.length; i++){
			if (document.getElementById("linkalert-show-" + LinkAlert.iconExtensionIDs[i]).checked == true){
				showExtensions += (LinkAlert.iconExtension[i] + ":" + LinkAlert.iconExtensionSrc[i] +";");
			}
		}
		prefs.setCharPref("icons.extensions",showExtensions);
		//Set protocol prefs
		for(var i = 0; i < LinkAlert.iconProtocolSrc.length; i++){
			if (document.getElementById("linkalert-show-" + LinkAlert.iconProtocolIDs[i]).checked == true){
				showProtocols += (LinkAlert.iconProtocol[i] + ":" + LinkAlert.iconProtocolSrc[i] + ";");
			}
		}
		prefs.setCharPref("icons.protocols",showProtocols);
		
		
		customExtensions = "";
		customProtocols = "";
		//Save custom extensions
		for(var i = 0; i < LinkAlert.iconCustomExt.length; i++){
			var child = document.getElementById("linkalert-extensions-src").firstChild;
			if(child){
				var tempSrc = child.label;
				if(tempSrc != ""){
					for(var q = 0; q < LinkAlert.iconCustomExt[i].length; q++){
						if(LinkAlert.iconCustomExt[i][q] != ""){
							customExtensions += (LinkAlert.iconCustomExt[i][q] + ",");
						}
					}
					customExtensions += (":" + tempSrc + ";");
				}
				document.getElementById("linkalert-extensions-src").removeChild(child);
			}
		}
		prefs.setCharPref("icons.custom.extensions",customExtensions);
		//Save custom protocols
		for(var i = 0; i < LinkAlert.iconCustomProto.length; i++){
			var child = document.getElementById("linkalert-protocols-src").firstChild;
			if(child){
				var tempSrc = child.label;
				if(tempSrc != ""){
					for(var q = 0; q < LinkAlert.iconCustomProto[i].length; q++){
						if(LinkAlert.iconCustomProto[i][q] != ""){
							customProtocols += (LinkAlert.iconCustomProto[i][q] + ",");
						}
					}
					customProtocols += (":" + tempSrc + ";");
				}
				document.getElementById("linkalert-protocols-src").removeChild(child);
			}
		}
		prefs.setCharPref("icons.custom.protocols",customProtocols);
		//Save priority
		var priorityTemp = "";
		for(var i = 4; i >= 0; i--){
			var tempItem = document.getElementById("linkalert-priority").lastChild;
			priorityTemp += tempItem.value
			document.getElementById("linkalert-priority").removeChild(tempItem);
			if(i != 0){ priorityTemp += ","; }
		}
		prefs.setCharPref("priority",priorityTemp);
	},// END function savePrefs
	
	updateExtensions:function(){
		var i = document.getElementById("linkalert-extensions-src").selectedIndex;
		while(document.getElementById("linkalert-extensions-ext").hasChildNodes()){
			var child = document.getElementById("linkalert-extensions-ext").firstChild;
			var old = document.getElementById("linkalert-extensions-ext").removeChild(child);
		}
		if(i >= 0){
			for(var q = 0; q < LinkAlert.iconCustomExt[i].length-1; q++){
				var tempValue = LinkAlert.iconCustomExt[i][q];
				if(tempValue != ""){
					var tempItem = document.createElement("listitem");
					tempItem.setAttribute("id","linkalert-extensions-ext-"+tempValue);
					tempItem.setAttribute("label",tempValue);
					document.getElementById("linkalert-extensions-ext").appendChild(tempItem);
				}
			}
		document.getElementById("linkalert-extensions-src-in").value = document.getElementById("linkalert-extensions-src").selectedItem.label;
		}
	},
	updateProtocols:function(){
		var i = document.getElementById("linkalert-protocols-src").selectedIndex;
		while(document.getElementById("linkalert-protocols-proto").hasChildNodes()){
			var child = document.getElementById("linkalert-protocols-proto").firstChild;
			var old = document.getElementById("linkalert-protocols-proto").removeChild(child);
		}
		if(i >= 0){
			for(var q = 0; q < LinkAlert.iconCustomProto[i].length-1; q++){
				var tempValue = LinkAlert.iconCustomProto[i][q];
				if(tempValue != ""){
					var tempItem = document.createElement("listitem");
					tempItem.setAttribute("id","linkalert-protocols-proto-"+tempValue);
					tempItem.setAttribute("label",tempValue);
					document.getElementById("linkalert-protocols-proto").appendChild(tempItem);
				}
			}
		}
		document.getElementById("linkalert-protocols-src-in").value = document.getElementById("linkalert-protocols-src").selectedItem.label;
	},
	
	addExt:function(){
		var tempValue = document.getElementById("linkalert-extensions-ext-in").value;
		if(tempValue != ""){
			var i = document.getElementById("linkalert-extensions-src").selectedIndex;
			var first = document.getElementById("linkalert-extensions-ext").firstChild;
			var tempItem = document.createElement("listitem");
			tempItem.setAttribute("id","linkalert-extensions-ext-"+tempValue);
			tempItem.setAttribute("label",tempValue);
			document.getElementById("linkalert-extensions-ext").insertBefore(tempItem,first);
			LinkAlert.iconCustomExt[i].unshift(tempValue);
			document.getElementById("linkalert-extensions-ext-in").value = "";
		}
	},
	removeExt:function(){
		var i = document.getElementById("linkalert-extensions-src").selectedIndex;
		var q = document.getElementById("linkalert-extensions-ext").selectedIndex;
		var tempValue = LinkAlert.iconCustomExt[i][q];
		var old = document.getElementById("linkalert-extensions-ext-"+tempValue);
		document.getElementById("linkalert-extensions-ext").removeChild(old);
		LinkAlert.iconCustomExt[i].splice(q,1);
	},
	addExtSrc:function(){
		var tempValue = document.getElementById("linkalert-extensions-src-in").value;
		if(tempValue != ""){
			var iconPath = LinkAlert.replacePath(tempValue);
			var first = document.getElementById("linkalert-extensions-src").firstChild;
			var tempItem = document.createElement("listitem");
			tempItem.setAttribute("id","linkalert-extensions-src-"+tempValue);
			tempItem.setAttribute("label",tempValue);
			tempItem.setAttribute("class","listitem-iconic");
			tempItem.setAttribute("image",iconPath);
			document.getElementById("linkalert-extensions-src").appendChild(tempItem);
			var tempBlank = new Array("");
			LinkAlert.iconCustomExt.push(tempBlank);
			document.getElementById("linkalert-extensions-src").selectItem(document.getElementById("linkalert-extensions-src-"+tempValue));
		}
	},
	setExtSrc:function(){
		var tempValue = document.getElementById("linkalert-extensions-src-in").value;
		var tempItem = document.getElementById("linkalert-extensions-src").selectedItem;
		var iconPath = LinkAlert.replacePath(tempValue);
		tempItem.setAttribute("label",tempValue);
		tempItem.setAttribute("image",iconPath);
		tempItem.setAttribute("id","linkalert-extensions-src-"+tempValue);
	},
	removeExtSrc:function(){
		var i = document.getElementById("linkalert-extensions-src").selectedIndex;
		var tempValue = document.getElementById("linkalert-extensions-src").selectedItem.label;
		while(document.getElementById("linkalert-extensions-ext").hasChildNodes()){
			var child = document.getElementById("linkalert-extensions-ext").firstChild;
			var old = document.getElementById("linkalert-extensions-ext").removeChild(child);
		}
		var old = document.getElementById("linkalert-extensions-src-"+tempValue);
		document.getElementById("linkalert-extensions-src").removeChild(old);
		LinkAlert.iconCustomExt.splice(i,1);
	},
	
	addProto:function(){
		var tempValue = document.getElementById("linkalert-protocols-proto-in").value;
		if(tempValue != ""){
			var i = document.getElementById("linkalert-protocols-src").selectedIndex;
			var first = document.getElementById("linkalert-protocols-proto").firstChild;
			var tempItem = document.createElement("listitem");
			tempItem.setAttribute("id","linkalert-protocols-proto-"+tempValue);
			tempItem.setAttribute("label",tempValue);
			document.getElementById("linkalert-protocols-proto").insertBefore(tempItem,first);
			LinkAlert.iconCustomProto[i].unshift(tempValue);
			document.getElementById("linkalert-protocols-proto-in").value = "";
		}
	},
	removeProto:function(){
		var i = document.getElementById("linkalert-protocols-src").selectedIndex;
		var q = document.getElementById("linkalert-protocols-proto").selectedIndex;
		var tempValue = LinkAlert.iconCustomProto[i][q];
		var old = document.getElementById("linkalert-protocols-proto-"+tempValue);
		document.getElementById("linkalert-protocols-proto").removeChild(old);
		LinkAlert.iconCustomProto[i].splice(q,1);
	},
	addProtoSrc:function(){
		var tempValue = document.getElementById("linkalert-protocols-src-in").value;
		if(tempValue != ""){
			var iconPath = LinkAlert.replacePath(tempValue);
			var first = document.getElementById("linkalert-protocols-src").firstChild;
			var tempItem = document.createElement("listitem");
			tempItem.setAttribute("id","linkalert-protocols-src-"+tempValue);
			tempItem.setAttribute("label",tempValue);
			tempItem.setAttribute("class","listitem-iconic");
			tempItem.setAttribute("image",iconPath);
			document.getElementById("linkalert-protocols-src").appendChild(tempItem);
			var tempBlank = new Array("");
			LinkAlert.iconCustomProto.push(tempBlank);
			document.getElementById("linkalert-protocols-src").selectItem(document.getElementById("linkalert-protocols-src-"+tempValue));
		}
	},
	setProtoSrc:function(){
		var tempValue = document.getElementById("linkalert-protocols-src-in").value;
		var tempItem = document.getElementById("linkalert-protocols-src").selectedItem;
		var iconPath = LinkAlert.replacePath(tempValue);
		tempItem.setAttribute("label",tempValue);
		tempItem.setAttribute("image",iconPath);
		tempItem.setAttribute("id","linkalert-protocols-src-"+tempValue);
	},
	removeProtoSrc:function(){
		var i = document.getElementById("linkalert-protocols-src").selectedIndex;
		var tempValue = document.getElementById("linkalert-protocols-src").selectedItem.label;
		while(document.getElementById("linkalert-protocols-proto").hasChildNodes()){
			var child = document.getElementById("linkalert-protocols-proto").firstChild;
			var old = document.getElementById("linkalert-protocols-proto").removeChild(child);
		}
		var old = document.getElementById("linkalert-protocols-src-"+tempValue);
		document.getElementById("linkalert-protocols-src").removeChild(old);
		LinkAlert.iconCustomProto.splice(i,1);
	},
	
	setPriority:function(updown){
		var i = document.getElementById("linkalert-priority").selectedIndex;
		var tempChild = document.getElementById("linkalert-priority").selectedItem;
		if(updown == true && i > 0){
			var placeChild = tempChild.previousSibling;
			tempChild = document.getElementById("linkalert-priority").removeChild(tempChild);
			document.getElementById("linkalert-priority").insertBefore(tempChild,placeChild);
			i++;
		}else if(updown == false && i < document.getElementById("linkalert-priority").childNodes.length-1){
			var placeChild = tempChild.nextSibling.nextSibling;
			tempChild = document.getElementById("linkalert-priority").removeChild(tempChild);
			document.getElementById("linkalert-priority").insertBefore(tempChild,placeChild);
			i--;
		}
		document.getElementById("linkalert-priority").selectItem(tempChild);
	},
	
	openFileSelect:function(toID){
		var fsw = window.openDialog("chrome://linkalert/content/fileselect.xul","fswindow","dialog,dependent=yes",toID);
	},
	
	replacePath:function(path,force){
		path = path.replace(/%LASKIN%/g,"chrome://linkalert/skin");
		if((document.getElementById("linkalert-large-icons").checked == true || force == 2) && force != 1){
			path = path.replace(/%LASIZE%/g,"large");
			path = path.replace(/%LASIZEPX%/g,"32");
		}else{
			path = path.replace(/%LASIZE%/g,"small");
			path = path.replace(/%LASIZEPX%/g,"16");
		}
		return path;
	},
	
	checkBound:function(boxID,min,max){
		var box = document.getElementById(boxID);
		if(box.value < min)
			box.value = min;
		if(box.value > max)
			box.value = max;
	},
	
	opacityDemo:function(){
		LinkAlert.checkBound('linkalert-opacity',0,100);
		var demoBox = document.getElementById("linkalert-display-demo");
		var demoStyle = "top:16px;left:16px;";
		if(document.getElementById("linkalert-background-check").checked == true)
		{demoStyle += ("background-color:" + document.getElementById("linkalert-background-color").color + ";");}
		if(document.getElementById("linkalert-border-check").checked == true)
		{demoStyle += ("border:" + document.getElementById("linkalert-border-color").color + " " + document.getElementById("linkalert-border-width").value + "px solid;");}
		demoBox.setAttribute("style",demoStyle);
		demoBox.setAttribute("src",LinkAlert.replacePath(demoIcon,0));
		demoBox.style.opacity = (document.getElementById("linkalert-opacity").value/100);
	}
}// END LinkAlert

//Set Event Listners
window.addEventListener("load", function() { LinkAlert.loadPrefs(); }, false);